#include "../e1.h"
#include <stdlib.h>
#include <stdio.h>
#include <errno.h>

int read_file(char *filename, void **buffer, size_t *size){
    FILE* fd = NULL;
    *buffer = NULL;
    fd = fopen(filename, "rb");
    if (fd == NULL) goto cleanup;
    if (fseek(fd, 0, SEEK_END) == -1) goto cleanup;
    *size = ftell(fd);
    if (*size == -1) goto cleanup;
    if (fseek(fd, 0, SEEK_SET) == -1) goto cleanup;
    *buffer = malloc(*size);
    if (*buffer == NULL) goto cleanup;
    if (fread(*buffer, 1, *size, fd) != *size) goto cleanup;
    fclose(fd);
    return 0;
cleanup: ;
    int curr_errno = errno;
    if (fd != NULL) fclose(fd);
    if (*buffer != NULL) free(*buffer);
    *size = 0;
    errno = curr_errno;
    return -1;
}
